// Machine.cpp 
//
//  Copyright (c) 2000 by Kirk B. Davis (kdavis@ndx.net). Free for non-business use.
//  No warrantee expressed or implied. Any use is at your own risk.



#include "stdafx.h"
#include "winpdp.h"
#include "Machine.h"

#include "winsock.h" // for timeval

#include "winpdpDoc.h"
#include "winpdpView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CWnd *gWnd = NULL;


void wSetRaw() {
	gView->Raw = TRUE;
}

void wResetRaw() {
	gView->Raw = FALSE;
}

#if 0
#define printf0(x) {char buf[80]; sprintf(buf, x); print(buf);}

void CWinioView::print(char *s) {
	while(*s != 0)
		SendMessage(WM_CHAR, (*s++ + 128), 0);
}
#endif

void wputchar(char c) {
	if (gView->Raw && c == 10)
		return;

	int len = gView->GetWindowTextLength();
	gView->SendMessage(EM_SETSEL, len, len);

	gView->SendMessage(WM_CHAR, c, 2);
}
void wprintf0(char *s) {
#if 0 // doesn't work on CE

	ASSERT(s && strlen(s) < 1000);

	char buf[1000];

	strcpy(buf, s);

	int i;

	for (i = 0; i < strlen(buf); i++)
		if (buf[i] == 10) {

			buf[i] = 13;
			//buf[++i] = 10;
			//buf[++i] = 0;
		}

	int len = gView->GetWindowTextLength();
	gView->SendMessage(EM_SETSEL, len, len);
	gView->SendMessage(EM_REPLACESEL, (WPARAM) true, (LPARAM)s);
#else
	int len = gView->GetWindowTextLength();
	gView->SendMessage(EM_SETSEL, len, len);
	while(*s != 0)
		gView->SendMessage(WM_CHAR, *s++, 2);
#endif
}
void wprintf1(char *s, long v) {
	char buf[128];

	sprintf(buf, s, v);
	wprintf0(buf);
}

void wprintf2(char *s, long v, long v1) {
	char buf[128];

	sprintf(buf, s, v, v1);
	wprintf0(buf);
}

void wprintf3(char *s, long v, long v1, long v2) {
	char buf[128];

	sprintf(buf, s, v, v1, v2);
	wprintf0(buf);
}

void wprintf4(char *s, long v, long v1, long v2, long v3){
	char buf[128];

	sprintf(buf, s, v, v1, v2, v3);
	wprintf0(buf);
}

char *wgets(char *s) {
	char *cp = s;
	char lastChar;

	for (;;) {
		if (gView->rbTail == gView->rbHead) {
			Sleep(100);
			continue;
		}

		lastChar = *cp++ = gView->rb[gView->rbTail++];
		gView->rbTail &= RB_SIZE;

		if (lastChar == 13)
			break;

		if (lastChar == 8) {
			cp--;

			if (cp != s)
				cp--;
		}	
	}

	*--cp = 0;

	return s;
}

char  wgetchar() {
	char lastChar;

	for (;;) {

		if (gView->rbTail == gView->rbHead) {
			Sleep(100);
			continue;
		}

		lastChar = gView->rb[gView->rbTail++];
		gView->rbTail &= RB_SIZE;

		break;
	}

	return lastChar;
}

bool CheckAndResetBreak() {
	if (gView->bBreak) {
		gView->bBreak = false;
		return true;
	}

	return false;
}


int charAvail() {
	return (!(gView->rbTail == gView->rbHead));
}
 
gettimeofday( timeval *tv) {
	SYSTEMTIME Time;

	GetSystemTime(&Time);

	tv->tv_usec = Time.wMilliseconds;
	tv->tv_sec = Time.wSecond;
}

/////////////////////////////////////////////////////////////////////////////
// CMachine

//IMPLEMENT_DYNCREATE(CMachine, CWinThread)

CMachine::CMachine(CWnd* pWnd)
{
	m_pMainWnd = pWnd;
}

CMachine::~CMachine()
{
}


BOOL CMachine::InitInstance()
{
	// TODO:  perform and per-thread initialization here

	while (!gWnd);

	extern int main();

	main();

	return TRUE;
}

int CMachine::ExitInstance()
{
	// TODO:  perform any per-thread cleanup here
	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(CMachine, CWinThread)
	//{{AFX_MSG_MAP(CMachine)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMachine message handlers

void CMachine::OnEditCopy() 
{
	// TODO: Add your command handler code here
	
}

void CMachine::OnAppAbout() 
{
	// TODO: Add your command handler code here
	
}
